/*	
 *	main.c
 *
 *	USBXg[W
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Sep 12 22:31:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <string.h>
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"
#include "d12ci.h"
#include "usbsys.h"

void fat_init();
void fat_exit();
extern unsigned rx_cnt;
extern unsigned tx_cnt;
extern unsigned err_cnt;

extern USBINFO ui;	/* usbusr.cŒ` */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* FATt@CVXeB */
	fat_init();
}

void
pceAppProc(int count)
{
	int joy;

	/* * pceAppInit()̒łȂtbNƁA
	 *   srft@CrunR}hŎsꍇɁArunR}h
	 *   vOJnołɃ^CAEgĂ܂܂B
	 *   runR}h^CAEgĂɖ͂܂񂪁A
	 *   CIɃCȂ̂ŁAx点ĂtbN܂B
	 * * pext@C̏ꍇ͂ȂtbNĂ\܂񂪁A
	 *   srfpex̔f̂ŁAx点邱Ƃɂ܂B
	 */
	if(count == 5) usb_hook(&ui);

	/* SELECT{^ꂽAI܂B */
	joy = pcePadGet();
	if(joy & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* ʕ\B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(0);
	pceFontSetBkColor(3);
	pceFontSetPos((DISP_X - 10 * 13) / 2, 0);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("==== traXg[W ====");
	pceFontSetTxColor(3);
	pceFontSetBkColor(0);
	pceFontSetPos(4, 24);
	pceFontPrintf("ǎoCgF%8u\n", tx_cnt % 100000000);
	pceFontSetPos(4, 39);
	pceFontPrintf("݃oCgF%8u\n", rx_cnt % 100000000);
	pceFontSetPos(4, 54);
	pceFontPrintf("Ήv񐔁F%8u\n", err_cnt % 100000000);
	pceFontSetTxColor(0);
	pceFontSetBkColor(2);
	pceFontSetPos((DISP_X - 10 * 13) / 2, DISP_Y - 10);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr(" SELECT{^ŏI܂ ");
	pceLCDTrans();
}

void
pceAppExit()
{
	/* mɃtbN܂B
	 * (܂tbNĂȂꍇɌĂłSł)
	 */
	usb_unhook();

	/* ʕ\B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(0);
	pceFontSetPos((DISP_X - 10 * 13) / 2, (DISP_Y - 10) / 2 - 7);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("@fBXNC[Wۑ@");
	pceFontSetPos((DISP_X - 10 * 13) / 2, (DISP_Y - 10) / 2 + 7);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("@΂炭҂@");
	pceLCDTrans();

	/* FATt@CVXeN[AbvB */
	fat_exit();
}
